# RPM spec file for GHC
#
# Copyright [1998..2002] Manuel M. T. Chakravarty <chak@acm.org>
# Thanks to Zoltan Vorosbaranyi <vbzoli@vbzo.li> for suggestions in 
# earlier versions and Pixel <pixel@mandrakesoft.com> for coding tips.
#
# This file is subject to the same free software license as GHC.

# Values for 5.02 are set by the `configure' script.  
# SNAP releases are CVS snapshots.  Official releases should replace SNAP by
# an appropriate release numbers (they are usually numbered starting from 1).
Name: ghc
Version: 6.2.1.20040316
Release: alt4

Summary: Glasgow Haskell Compilation system
Copyright: BSD style w/o adv. clause
Group: Development/Haskell
Packager: Vitaly Lugovsky <vsl@altlinux.ru>
Source: http://haskell.org/ghc/dist/%{version}/ghc-%{version}-src.tar.bz2
URL: http://haskell.org/ghc/
Patch1: ghc-%{version}-docbook.patch
Patch2: ghc-%{version}-arinput.patch
Requires: gmp-devel
Obsoletes: happy

BuildRequires: XFree86-devel docbook-utils-print docbook-dtds docbook-style-dsssl flex ghc gtk+-devel jadetex libGLU-devel libelf-devel libglut-devel libgmp-devel libncurses-devel libreadline-devel openjade sgml-common tetex-core tetex-dvips tetex-latex time urw-tex xml-common

BuildRequires: ghc >= 6.2.1.20040316-alt3, docbook-utils, gmp, gmp-devel, libreadline-devel
BuildRequires: libncurses-devel, jadetex

%description
Haskell is a standard lazy functional programming language; the
current language version is Haskell 98, agreed in December 1998.

GHC is a state-of-the-art programming suite for Haskell.  Included is
an optimising compiler generating good code for a variety of
platforms, together with an interactive system for convenient, quick
development.  The distribution includes space and time profiling
facilities, a large collection of libraries, and support for various
language extensions, including concurrency, exceptions, and foreign
language interfaces (C, C++, whatever).

A wide variety of Haskell related resources (tutorials, libraries,
specifications, documentation, compilers, interpreters, references,
contact information, links to research groups) are available from the
Haskell home page at <http://www.haskell.org/>.

%package prof
Summary: Profiling libraries for GHC
Group: Development/Haskell
Requires: ghc = %{PACKAGE_VERSION}

%description prof
Profiling libraries for Glorious Glasgow Haskell Compilation System (GHC).
They should be installed when GHC's profiling subsystem is needed.

%package doc
Summary: Documentation for GHC
Group: Development/Haskell

%description doc
Preformatted documentation for the Glorious Glasgow Haskell Compilation System 
(GHC) and its libraries.  It should be installed if you like to have local
access to the documentation in PostScript and HTML format.  Alternatively,
the documentation is available online at

  http://haskell.org/ghc/documentation.html


%prep
%setup
%patch1 -p1
%patch2 -p1

# generate our own `build.mk'
#
# * this is a kludge (is it still needed?)
#
cat >mk/build.mk <<END
GhcLibWays = p
SRC_HAPPY_OPTS += -agc
#GhcWithInterpreter=NO
GhcWithInterpreter=YES
END

# run autoconf if necessary
#
[ ! -x configure ] && autoconf && cd ghc && autoconf

%build
./configure --prefix=%{prefix}
make boot
make -C glafp-utils sgmlverb
make all
make -C docs html
make -C ghc/docs html

%install
# compress the non-html docs
#
for j in docs ghc/docs; do
  dir=`pwd`
  cd $j
  for i in ps dvi sgml verb idx; do
    find . -name '*.'$i -exec gzip -9 '{}' ';' -print
  done
  cd $dir
done
rm -rf $RPM_BUILD_ROOT

# FIXME: this is necessary due to brokenness in ghc-5.00/mk/target.mk
make prefix=$RPM_BUILD_ROOT%{prefix} install-dirs

make prefix=$RPM_BUILD_ROOT%{prefix} install

# generate the file list for lib/ _excluding_ all files needed for profiling
# only
#
# * generating file lists in a BUILD_ROOT spec is a bit tricky: the file list
#   has to contain complete paths, _but_ without the BUILD_ROOT, we also do
#   _not_ want have directory names in the list; furthermore, we have to make
#   sure that any leading / is removed from %{prefix}/lib, as find has to 
#   interpret the argument as a relative path; however, we have to include the
#   leading / again in the final file list (otherwise, rpm complains)
# * isn't there an easier way to do all this?
#
dir=`pwd`
cd $RPM_BUILD_ROOT
libdir=`echo %{prefix}/lib | sed 's|^/||'`
find $libdir ! -type d ! -name '*.p_hi' ! -name '*_p.a' -print | sed 's|^|/|'\
     >$dir/rpm-noprof-lib-files
find $libdir ! -type d -name '*.p_hi' -print | sed 's|^|/|'\
     >$dir/rpm-prof-lib-files
find $libdir ! -type d -name '*_p.a' -print | sed 's|^|/|'\
     >>$dir/rpm-prof-lib-files
cd $dir

%files -f rpm-noprof-lib-files
%doc ghc/ANNOUNCE ghc/README
%{prefix}/bin/*

%files prof -f rpm-prof-lib-files

%files doc
%doc docs/
%doc ghc/docs/


%changelog
* Thu May 13 2004 Alexey Voinov <voins@altlinux.ru> 6.2.1.20040316-alt4
- fix build dep
- remove unneeded %defines

* Mon May 10 2004 Vitaly Lugovsky <vsl@altlinux.ru> 6.2.1.20040316-alt3
- glibc2.3 rebuild

* Wed May 05 2004 Vitaly Lugovsky <vsl@altlinux.ru> 6.2.1.20040316-alt2.1
- a temporary re-bootstrap binary release

* Thu Mar 18 2004 Vitaly Lugovsky <vsl@altlinux.ru> 6.2.1.20040316-alt2
- profile .p_hi fixes

* Wed Mar 17 2004 Vitaly Lugovsky <vsl@altlinux.ru> 6.2.1.20040316-alt1
- a new version

* Wed Dec 17 2003 Vitaly Lugovsky <vsl@altlinux.ru> 6.2-alt1
New version

* Mon Oct 13 2003 Vitaly Lugovsky <vsl@altlinux.ru> 6.0.1-alt1
new version


* Sun Jun 29 2003 Vitaly Lugovsky <vsl@altlinux.ru> 6.0-alt1
- new version released

* Tue Apr 01 2003 Vitaly Lugovsky <vsl@altlinux.ru> 5.04.3-alt1
- new version released

* Fri Jan 24 2003 Vitaly Lugovsky <vsl@altlinux.ru> 5.04.2-alt1
- a new version

* Sat Dec 28 2002 Vitaly Lugovsky <vsl@altlinux.ru> 5.04.1-alt3
- spec cleanup, again

* Mon Dec 09 2002 Vitaly Lugovsky <vsl@altlinux.ru> 5.04.1-alt2
- spec cleanup

* Fri Dec 06 2002 Vitaly Lugovsky <vsl@altlinux.ru> 5.04.1-alt1
- new version

* Wed Jul 31 2002 Vitaly Lugovsky <vsl@altlinux.ru> 5.04
- New version released

* Tue May 14 2002 Vitaly Lugovsky <vsl@altlinux.ru> 5.02.3-alt4
- Get rid of virtual package 'haskell'.

*Sun May 12 2002 Vitaly Lugovsky <vsl@altlinx.ru> 5.02.3-alt3
- BuildRoot and %clean removed to conform ALTLinux packaging
  policy.

*Sat Apr 27 2002 Vitaly Lugovsky <vsl@altlinux.ru> 5.02.3-alt2
- Slightly adopted to the ALT Linux environment.

* Wed Sep 26 2001 Manuel Chakravarty
- split documentation off into a separate package
- adapt to new docbook setup in RH7.1

* Mon Apr 16 2001 Manuel Chakravarty
- revised for 5.00
- also runs autoconf automagically if no ./configure found

* Thu Jun 22 2000 Sven Panne
- removed explicit usage of hslibs/docs, it belongs to ghc/docs/set

* Sun Apr 23 2000 Manuel Chakravarty
- revised for ghc 4.07; added suggestions from Pixel <pixel@mandrakesoft.com>
- added profiling package

* Tue Dec 7 1999 Manuel Chakravarty
- version for use from CVS

* Thu Sep 16 1999 Manuel Chakravarty
- modified for GHC 4.04, patchlevel 1 (no more 62 tuple stuff); minimises use
  of patch files - instead emits a build.mk on-the-fly

* Sat Jul 31 1999 Manuel Chakravarty
- modified for GHC 4.04

* Wed Jun 30 1999 Manuel Chakravarty
- some more improvements from vbzoli

* Fri Feb 26 1999 Manuel Chakravarty
- modified for GHC 4.02

* Thu Dec 24 1998 Zoltan Vorosbaranyi 
- added BuildRoot
- files located in /usr/local/bin, /usr/local/lib moved to /usr/bin, /usr/lib

* Tue Jul 28 1998 Manuel Chakravarty
- original version
